const XLSX = require('xlsx');
const fs = require('fs');

// Read the CSV file and convert it to JSON
const wb = XLSX.readFileSync('./oh3d.csv');
const oh3d = XLSX.utils.sheet_to_json(wb.Sheets.Sheet1);

const template = fs.readFileSync('./_OH3D_template.html');

// Loop through each row
oh3d.forEach((asset) => {
    // Get template file content
    let newFileContent = template.toString();
    // Replace all fields in template
    Object.keys(asset).forEach((key) => {
        let temp = `\\*\\*\\*${key}\\*\\*\\*`;
        let regex = new RegExp(temp, "g");
        newFileContent = newFileContent.replace(regex, asset[key]);
    });

    // Use the DOI_SHORT field as file name, fall back on TITLE if it's null
    let fileName = (asset.DOI_SHORT ?? asset.TITLE)
    // Sanitize file name (remove "/" since it's invalid)
            .replace(/\//g, ".");

    // Write contents of new file
    fs.writeFile(`./oh3d/${fileName}.html`, newFileContent, (err) => {
        if (err) throw err;
        console.log(`Created file ${fileName}.html`);
    });
});